// File Sat/Clausola.java
import java.util.*;
public class Clausola implements Cloneable {
    private HashSet<Letterale> contiene;
    public static final Clausola CLAUSOLA_VUOTA = new Clausola();
    public Clausola() {
        contiene = new HashSet<Letterale>();
    }
    public void inserisciLinkContiene(Letterale lit) {
        if (lit != null) contiene.add(lit);
    }
    public void eliminaLinkContiene(Letterale lit) {
        if (lit != null) contiene.remove(lit);
    }
    public boolean isEmpty() {
	return contiene.isEmpty();
    }
    public Set<Letterale> getContiene() {
        return (HashSet<Letterale>)contiene.clone();
    }
    public Object clone() {
        try {
            Clausola d = (Clausola)super.clone(); 
            d.contiene = new HashSet<Letterale>();
            Iterator<Letterale> it = getContiene().iterator();
            while(it.hasNext()) {
                Letterale elem = it.next();
                d.inserisciLinkContiene(elem);
	    }
            return d;
	} catch (CloneNotSupportedException e) {
            // non pu accadere, ma va comunque gestito
            throw new InternalError(e.toString());
        }
    }
    public String toString() {
	String result = new String("(");
	Iterator<Letterale> it = getContiene().iterator();
	while(it.hasNext()) {
	    Letterale elem = it.next();
	    result += elem + " ";
	}
	result += ")";
        return result;
    }
}
