// File FileIn.java
// Time-stamp: "2006-03-22 10:25:53 cadoli"

// Classe per:
//  - lettura da file (sempre lo stesso, deve essere inizialzzato)
// tipi base + String

import java.io.*;
import java.util.StringTokenizer;

public class FileIn {
    private static StringTokenizer st;
    private static BufferedReader in;
    private static StringTokenizer reload() {
	try {
	    String line = in.readLine();
	    return new StringTokenizer(line);
	} catch(IOException e){
	    System.err.println("Errore di IO\n"+e);
	    return null;
	}
    }

    public FileIn(String nome_file_input) throws FileNotFoundException {
	st = null;
	FileInputStream istream = new FileInputStream(nome_file_input);
	in = new BufferedReader(new InputStreamReader(istream));
    }

    public static void flush() {
	// skips until EOL
	st = null;
    }

    public String readString() {
	if (st == null || !st.hasMoreTokens()) st = reload();
	if (st == null) return null;
	else return st.nextToken();
    }
    
    public char readChar() {
	if (st == null || !st.hasMoreTokens()) st = reload();
	return st.nextToken().charAt(0);
    }
    
    public int readInt() {
	if (st == null || !st.hasMoreTokens()) st = reload();
	return Integer.parseInt(st.nextToken());
    }
    
    public long readLong() {
	if (st == null || !st.hasMoreTokens()) st = reload();
	return Long.parseLong(st.nextToken());
    }
    
    public short readShort() {
	if (st == null || !st.hasMoreTokens()) st = reload();
	return Short.parseShort(st.nextToken());
    }
    
    public float readFloat() {
	if (st == null || !st.hasMoreTokens()) st = reload();
	return Float.valueOf(st.nextToken()).floatValue();
    }
    
    public double readDouble() {
	if (st == null || !st.hasMoreTokens()) st = reload();
	return Double.valueOf(st.nextToken()).doubleValue();
    }
}
