// File Sat/Test.java

import java.util.*;
import java.io.*;

public final class Test {
    public static void testBT(FormulaCNF cnf) {
        System.out.println("*** TEST risolviConBacktracking");
	Assegnazione mod = Solutori.risolviConBacktracking(cnf);
	if (mod != null)
	    System.out.println(cnf + " ha come modello " + mod);
	else
	    System.out.println(cnf + " e' insoddisfacibile");
        System.out.println("**************");
    }

    public static void test1() {
	// test funzioni classe FormulaCNF
	Variabile s = new Variabile("s"),
	    p = new Variabile("p"),
	    q = new Variabile("q");
	Letterale p_pos = new Letterale(p,true),
	    p_neg = new Letterale(p,false),
	    q_pos = new Letterale(q,true),
	    q_neg = new Letterale(q,false),
	    s_neg = new Letterale(s,false),
	    s_pos = new Letterale(s,true);
	Clausola c1 = new Clausola(), c2 = new Clausola(), 
	    c3 = new Clausola(), c4 = new Clausola(), c5 = new Clausola(),
	    c6 = new Clausola();

	c1.inserisciLinkContiene(p_pos);
	c2.inserisciLinkContiene(q_pos);
	c2.inserisciLinkContiene(s_neg);
	c3.inserisciLinkContiene(q_pos);
	c4.inserisciLinkContiene(s_pos);
	c5.inserisciLinkContiene(q_neg);
	c5.inserisciLinkContiene(p_pos);
	c6.inserisciLinkContiene(p_neg);

	FormulaCNF cnf1 = new FormulaCNF();
	cnf1.inserisciLinkCostituitaDa(c1);
	cnf1.inserisciLinkCostituitaDa(c2);
        System.out.println("*** TEST inserisciLinkCostituitaDa");
        System.out.println(cnf1);
        System.out.println("**************");
	
	FormulaCNF cnf2 = (FormulaCNF)cnf1.clone();
	cnf2.inserisciLinkCostituitaDa(c3);
        System.out.println(cnf1);
        System.out.println(cnf2);
        System.out.println("**************");

	cnf2.eliminaLinkCostituitaDa(c1);
        System.out.println("*** TEST eliminaLinkCostituitaDa");
        System.out.println(cnf1);
        System.out.println(cnf2);
        System.out.println("**************");
	
	Assegnazione a1 = new Assegnazione();
	FormulaCNF cnf3 = cnf1.semplifica(a1);
        System.out.println("*** TEST semplifica");
        System.out.println(cnf1);
        System.out.println(cnf2);
        System.out.println(cnf3);
        System.out.println("**************");
	a1.inserisciLinkDi(q_neg);
	a1.inserisciLinkDi(p_pos);
	cnf3 = cnf1.semplifica(a1);
        System.out.println(cnf1);
        System.out.println(cnf2);
        System.out.println(cnf3);
        System.out.println("**************");

	FormulaCNF cnf4 = new FormulaCNF();
	cnf4.inserisciLinkCostituitaDa(c4);
	cnf4.inserisciLinkCostituitaDa(c2);
	cnf4.inserisciLinkCostituitaDa(c5);
	cnf4.inserisciLinkCostituitaDa(c6);

	testBT(cnf1);
	testBT(cnf2);
	testBT(cnf3);
	testBT(cnf4);
    }

    public static void test2() throws FileNotFoundException {
	// test lettura da file
	FormulaCNF miaCNF = FormulaCNF.leggiDaFileDIMACS("prova.cnf");
	System.out.println(miaCNF);
	testBT(miaCNF);
    }

    public static void main(String[] args) throws FileNotFoundException {
	test2();
    }
    private Test() { };
}
